#!/usr/bin/perl

# ARCADEmini converter: bmm2ambin
# version 1.0 date 2003-09-03
# part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
# written by 1stein <1stein@schuermans.info>
# based on blinkenplayer.pl by stray <stray@stray.ch>
# Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

print <<EOF;
ARCADEmini converter: bmm2ambin
version 1.0 date 2003-09-03
part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
written by 1stein <1stein\@schuermans.info>
based on blinkenplayer.pl by stray <stray\@stray.ch>
Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html

EOF

read_source( $ARGV[0] );

$file = $ARGV[1];
if( $file eq "" ) { $file = $ARGV[0] . ".ambin" };

open( F, "> " . $file ) || die "Can't open $file: $!\n";
binmode F;

printf F "ARCADEmini 26x20/16 ambin 1.0   ";
for( $i = 32; $i < 512; $i++ )
{
	print F pack( 'C', 0xFF );
}

$char[0] = " ";
$char[1] = " ";
$char[2] = " ";
$char[3] = " ";
$char[4] = "+";
$char[5] = "+";
$char[6] = "+";
$char[7] = "+";
$char[8] = "*";
$char[9] = "*";
$char[10] = "*";
$char[11] = "*";
$char[12] = "#";
$char[13] = "#";
$char[14] = "#";
$char[15] = "#";

$bytes = 0;
$bytes_sector = 0;
$frames = 0;
$sectors = 0;
for( $f = 0; $f <= $#del; $f++) {

	$chars = @{@{$frames[$f]}[0]};
	if( $chars > 26 ) { $chars = 26 };
	$lines = @{$frames[$f]};
	if( $lines > 20 ) { $lines = 20 };
	$left = (26 - $chars) / 2;
	$right = 26 - $chars - $left;
	$top = (20 - $lines) / 2;
	$bottom = 20 - $lines - $top;

	$nibble = 0;
	for( $i = 0; $i < 26 * $top; $i++, $nibble++ ) { @nibbles[$nibble] = 0; }
	$linenum = 0;
	foreach (@{$frames[$f]}) {
	  if( $linenum < 26 ) { for( $i = 0; $i < $left; $i++, $nibble++ ) { @nibbles[$nibble] = 0; } }
	  $charnum = 0;
	  foreach (@$_) {
		print($char[$_ / 0x10]);
		if( $linenum < 20 && $charnum < 26 ) {
		  @nibbles[$nibble] = $_ / 0x10;
		  $nibble++;
		}
		$charnum++;
	  }
	  if( $linenum < 26 ) { for( $i = 0; $i < $right; $i++, $nibble++ ) { @nibbles[$nibble] = 0; } }
	  print("\n");
	  $linenum++;
	}
	for( $i = 0; $i < 26 * $bottom; $i++, $nibble++ ) { @nibbles[$nibble] = 0; }

	if( $bytes_sector + 67 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xA5 );
	print F pack( 'C', 0x00 );
	for( $byte = 0; $byte < 65; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 0x10 + @nibbles[$byte*2+$nibble];
		}
		print F pack( 'C', $val );
	}
	$bytes += 67;
	$bytes_sector += 67;

	if( $bytes_sector + 67 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xA5 );
	print F pack( 'C', 0x01 );
	for( $byte = 65; $byte < 130; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 16 + @nibbles[$byte*2+$nibble];
		}
		print F pack( 'C', $val );
	}
	$bytes += 67;
	$bytes_sector += 67;

	if( $bytes_sector + 67 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xA5 );
	print F pack( 'C', 0x02 );
	for( $byte = 130; $byte < 195; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 16 + @nibbles[$byte*2+$nibble];
		}
		print F pack( 'C', $val );
	}
	$bytes += 67;
	$bytes_sector += 67;

	if( $bytes_sector + 67 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xA5 );
	print F pack( 'C', 0x03 );
	for( $byte = 195; $byte < 260; $byte++ ) {
		$val = 0;
		for( $nibble = 0; $nibble < 2; $nibble++ ) {
			$val = $val * 16 + @nibbles[$byte*2+$nibble];
		}
		print F pack( 'C', $val );
	}
	$bytes += 67;
	$bytes_sector += 67;

	if( $bytes_sector + 4 > 512 ) {
		$fill = 512 - $bytes_sector;
		for( $i = 0; $i < $fill; $i++ ) { print F pack( 'C', 0 ); }
		$bytes += $fill;
		$bytes_sector = 0;
		$sectors++;
	}
	print F pack( 'C', 0xC0 );
	print F pack( 'C', 0xC9 );
	print F pack( 'C', $del[$f] / 0x100 );
	print F pack( 'C', $del[$f] % 0x100 );
	$bytes += 4;
	$bytes_sector += 4;

	$frames++;
}

if( $bytes_sector > 0 )
{
	for( $i = 0; $i < 512 - $bytes_sector; $i++ ) { print F pack( 'C', 0 ); }
	$bytes += 512 - $bytes_sector;
	$bytes_sector = 0;
	$frames_sector = 0;
	$sectors++;
}

$jump_sectors = 0xFFFFFFFF - ($sectors - 1);
print F pack( 'C', 0x01 );
print F pack( 'C', ($jump_sectors / 0x1000000) % 0x100 );
print F pack( 'C', ($jump_sectors / 0x10000) % 0x100 );
print F pack( 'C', ($jump_sectors / 0x100) % 0x100 );
print F pack( 'C', ($jump_sectors / 0x1) % 0x100 );
for( $i = 5; $i < 512; $i++ )
{
	print F pack( 'C', 0x00 );
}

close F;

sub read_source {
  my $file = shift;
  open (F, $file) || die "Can't open $file: $!\n";
  foreach $line (<F>) {
	chomp $line; chomp $line;
	$line =~ s/#.*//;
	next unless $line =~ /\S+/;
	if ($line =~ /^\@(\d+)/) {
	  push(@del,$1);
	  $frame = $#del;
	  next;
	}
	push(@{$frames[$frame]}, [split(/ +/,$line)]); 
  }
  close F;
}
